#!/usr/bin/env python

from __future__ import division

import pygame
import inrelief

SCREENW = 800
SCREENH = 600
CENTERX = SCREENW // 2
CENTERY = SCREENH // 2

DARK = (20, 12, 28)
RED = (208, 70, 72)
ORANGE = (210, 125, 44)
YELLOW = (218, 212, 94)
LIGHT = (222, 238, 214)

FIERY = (DARK, RED, ORANGE, YELLOW)

pixels = (
	(0, 0, 0, 0, 0, 0, 0, 0),
	(0, 0, 0, 1, 1, 0, 0, 0),
	(0, 0, 1, 2, 2, 1, 0, 0),
	(0, 1, 2, 3, 3, 2, 1, 0),
	(0, 1, 2, 3, 3, 2, 1, 0),
	(0, 0, 1, 2, 2, 1, 0, 0),
	(0, 0, 0, 1, 1, 0, 0, 0),
	(0, 0, 0, 0, 0, 0, 0, 0))

fireball = inrelief.Sprite(pixels, FIERY)
fireball.set_hotspot(4, 4, -2)

stuff = inrelief.DisplayList()
stuff.append(fireball, 0, 0, 0)
stuff.append(fireball, -8, -5, 3)
stuff.append(fireball, 3, 5, -8)

camera = inrelief.Camera(0, 0, -34, SCREENH)


pygame.init()

screen = pygame.display.set_mode((SCREENW, SCREENH))
pygame.display.set_caption("InRelief Graphics Engine: basic demo")
pygame.event.set_blocked(pygame.MOUSEMOTION)

def renderer(x, y, size, color):
	x += CENTERX
	y += CENTERY
	screen.fill(color, (x, y, size, size))

screen.fill(DARK)

stuff.zsort()
stuff.render_through(camera, renderer)

pygame.draw.line(screen, LIGHT, (0, CENTERY), (SCREENW - 1, CENTERY))
pygame.draw.line(screen, LIGHT, (CENTERX, 0), (CENTERX, SCREENH - 1))

pygame.display.flip()
pygame.event.wait()
