local inrelief = require "inrelief"

local SCREENW = 800
local SCREENH = 600
local CENTERX = SCREENW / 2
local CENTERY = SCREENH / 2

local DARK = {0.08, 0.05, 0.1}
local RED = {0.81, 0.27, 0.28}
local ORANGE = {0.82, 0.49, 0.17}
local YELLOW = {0.85, 0.83, 0.37}
local LIGHT = {0.87, 0.93, 0.84}

local FIERY = {RED, ORANGE, YELLOW}

local pixels = {
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 1, 1, 0, 0, 0},
	{0, 0, 1, 2, 2, 1, 0, 0},
	{0, 1, 2, 3, 3, 2, 1, 0},
	{0, 1, 2, 3, 3, 2, 1, 0},
	{0, 0, 1, 2, 2, 1, 0, 0},
	{0, 0, 0, 1, 1, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}}

local fireball = inrelief.Sprite:new(pixels, FIERY)
fireball:set_hotspot(4, 4, -2)

stuff = inrelief.DisplayList:new()
stuff:insert(fireball, 0, 0, 0)
stuff:insert(fireball, -8, -5, 3)
stuff:insert(fireball, 3, 5, -8)
stuff:zsort()

local camera = inrelief.Camera:new {z = -34, f = SCREENH}

function love.load()
	love.window.setTitle("InRelief Graphics Engine: basic demo")
	love.graphics.setBackgroundColor(DARK)
end

function love.draw()
	love.graphics.translate(CENTERX, CENTERY)
	stuff:render_through(camera, renderer)

	love.graphics.setColor(LIGHT)
	love.graphics.line(-SCREENW / 2, 0, SCREENW / 2, 0)
	love.graphics.line(0, -SCREENH / 2, 0, SCREENH / 2)
end

function renderer(x, y, size, color)
	love.graphics.setColor(color)
	love.graphics.rectangle("fill", x, y, size, size)
end
